//
//  NSBitmapImageRep+Thumb.h
//  SFToolkit
//
//  Created by Konstantin Erokhin on 5/5/11.
//  Copyright 2011 Shiny Frog. All rights reserved.
//

#import <Foundation/Foundation.h>

CGImageRef sfCreateScaledCGImageFromCGImage(CGImageRef image,
                                            NSInteger destWidth,
                                            NSInteger destHeight,
                                            BOOL preserveRatio,
                                            BOOL shouldAntialias,
                                            BOOL resizeAndKeepAspectRatio,
                                            CGInterpolationQuality interpolationQuality,
                                            CGFloat alpha);


@interface NSBitmapImageRep (Thumb)

- (NSBitmapImageRep *) thumbForSize: (NSSize) imageSize 
					  preserveRatio: (BOOL) preserveRatio 
					 keepSquareRect: (BOOL) keepSquareRect 
				 imageInterpolation: (NSImageInterpolation) imageInterpolation
					shouldAntialias: (BOOL) shouldAntialias	
			correctWithColorProfile: (id) colorProfile
							  alpha: (float) alpha;


- (NSBitmapImageRep *) squareThumbForSize: (NSSize) imageSize 
                            preserveRatio: (BOOL) preserveRatio;

- (NSBitmapImageRep *) thumbForSize: (NSSize) imageSize 
                      preserveRatio: (BOOL) preserveRatio 
                              alpha: (float) alpha;

- (NSBitmapImageRep *) thumbForSize: (NSSize) size 
                      preserveRatio: (BOOL) preserveRatio;

@end
